<?php

class BlockBestSellers extends Module
{
	private $_html = '';
	private $_directory;
	private $_filename;
	private $_filename_http;
	private $_postErrors = array();

	function __construct()
    {
        $this->name = 'blockbestsellers';
        $this->tab = 'Blocks';
        $this->version = 0.8;

        parent::__construct();

        /* The parent construct is required for translations */
				$this->page = basename(__FILE__, '.php');
        $this->displayName = $this->l('Block best sellers');
        $this->description = $this->l('Shows best sellers in your shop right column');
    }

    function install()
    {
        parent::install();
        $this->registerHook('rightColumn');
        $this->registerHook('newOrder');
        ProductSale::fillProductSales();
    }


    function hookRightColumn($params)
    {
		global $smarty;
		$currency = new Currency(intval($params['cookie']->id_currency));
		$bestsellers = ProductSale::getBestSalesLight(intval($params['cookie']->id_lang), 0, 5);

		$best_sellers = array();
		if (!empty($bestsellers))
		{
			foreach ($bestsellers AS $bestseller)
			{
				$bestseller['price'] = Tools::displayPrice(Product::getPriceStatic(intval($bestseller['id_product'])), $currency);
				$best_sellers[] = $bestseller;
			}
		}

		$smarty->assign('best_sellers', $best_sellers);
		return $this->display(__FILE__, 'blockbestsellers.tpl');
	}
	
	function hookLeftColumn($params)
	{
		return $this->hookRightColumn($params);
	}
	
	function hookNewOrder($params)
	{
		foreach ($params['cart']->getProducts() as $product)
			ProductSale::addProductSale($product['id_product'], $product['quantity']);
	}
}

?>
